
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

extern void	Error();

static double	Sqr(r)
double		r;
{
	return r*r;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	N,M,m,n,a;
	double	xC,yC,dt,r0,t,rC,r2,f,R,R2_r2;
	FILE	*file;

	if (argc<7) Error("usage : cp_sg N xC yC R1 {R2 R3 ...} M SG");

	if ((N=atoi(argv[1]))<=0) Error("bad detector number.");

	xC=atof(argv[2]);
	yC=atof(argv[3]);

	if ((M=atoi(argv[argc-2]))<=0) Error("bad projection number.");

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\n",N,M);

	dt=M_PI/(double)M; r0=(double)(1-N)/2.0;
	for (m=0; m<M; m++) {
	    t=dt*(double)m; rC=r0-xC*cos(t)-yC*sin(t);
	    for (n=0; n<N; n++) {
		r2=Sqr(rC+(double)n); f=0.0;
		for (a=argc-3; a>=4; a--)
		    if ((R2_r2=Sqr(R=atof(argv[a]))-r2)>0.0)
			f+=(((R>0.0)?2.0:-2.0)*sqrt(R2_r2));

		(void)fwrite(&f,sizeof(f),(size_t)1,file);
	    }
	}
	if (file!=stdout) (void)fclose(file);

	return 0;
}
