
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,**Z,y,x,a,z,z1,z2;
	double	xC,yC,R,Rx,Ry;
	Cell	**cell;
	char	desc[256],*mae="memory allocation error.";

	if (argc<7) Error("usage : cp_tg Nx Ny xC yC R1 {R2 R3 ...} TIFF");

	if ((Nx=atoi(argv[1]))<=0 ||
	    (Ny=atoi(argv[2]))<=0) Error("bad image size.");

	if ((Z=(int **)malloc(sizeof(*Z)*(size_t)Ny))==NULL) Error(mae);

	for (y=0; y<Ny; y++) {
	    if ((Z[y]=(int *)malloc(sizeof(**Z)*(size_t)Nx))==NULL) Error(mae);

	    for (x=0; x<Nx; x++) Z[y][x]=0;
	}
	xC=atof(argv[3])+(double)(Nx-1)/2.0;
	yC=atof(argv[4])+(double)(Ny-1)/2.0;

	for (a=argc-2; a>4; a--) {
	    z=((R=atof(argv[a]))>0.0)?1:-1; R=R*R;
	    for (y=0; y<Ny; y++) {
		Ry=(double)y-yC; Ry=Ry*Ry-R;
		for (x=0; x<Nx; x++) {
		    Rx=(double)x-xC; if (Rx*Rx+Ry<=0.0) Z[y][x]+=z;
		}
	    }
	}
	z1=z2=Z[0][0];
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if (Z[y][x]<z1) z1=Z[y][x]; else if (Z[y][x]>z2) z2=Z[y][x];

	(void)printf("%d\t%d\n",z1,z2);

	if ((z2-=z1)>>8*sizeof(Cell)) Error("too many pixel values.");

	cell=(Cell **)Z;
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) cell[y][x]=(Cell)(Z[y][x]-z1);

	(void)sprintf(desc,"%d\t1",z1);
	StoreImageFile(argv[argc-1],Nx,Ny,
		       (z2<2)?1:(z2<4)?2:(z2<16)?4:(z2<256)?8:(z2<65536)?16:32,
		       cell,desc);
	return 0;
}
