
#include <stdio.h>
#include <stdlib.h>

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

int	main(int argc,char **argv)
{
	FILE	*file;
	int	L,l,M,m;
	char	*dre="data read error.",
		*dwe="data write error.";
	double	*P;

	if (argc!=3 && argc!=4)
	    Error("usage : rso_a2b projection {views} sinogram");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) Error("file not found.");

	if (fscanf(file,"%d",&L)!=1 || L<=0) Error(dre);

	if ((P=(double *)malloc(sizeof(*P)*(size_t)L))==NULL)
	    Error("memory allocation error.");

	for (l=0; l<L; l++) if (fscanf(file,"%lf",P+l)!=1) Error(dre);

	if (file!=stdin) (void)fclose(file);

	if (argc==3)
	    M=(int)(3.14159265358979323846*(double)L);
	else
	    if ((M=atoi(argv[2]))<=0) Error("bad number of views.");

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	if (fprintf(file,"%d\t%d\n",L*2-1,M)<0) Error(dwe);

	for (m=0; m<M; m++)
	    for (l=1-L; l<L; l++)
		if (fwrite(P+abs(l),sizeof(*P),(size_t)1,file)!=1) Error(dwe);

	if (file!=stdout) (void)fclose(file);

	return 0;
}
