
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

extern void	Error();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*Fi,*Fo;
	char	text[LEN];
	int	N0,M0,m,n,n0,N1,M1,n1,n2,N2,m0;
	double	**P,c0,r,c1,dr,ot,o1,o2,ox,oy,st,t,c2,sr,r0,p,p0,pr,pt;

	if (argc!=10 && argc!=11)
	Error("usage : sg_embed SG0 c0 SG1|(N1 M1) c1 dr0/dr1 ot dx dy SG2");

#define OPEN(path,SG)	\
	if (path[0]=='-') \
	    Fi=stdin; \
	else \
	    if ((Fi=fopen(path,"rb"))==NULL) Error(SG " file not found.")

	OPEN(argv[1],"SG0");

#define PIXELS(N,M,SG)	\
	if (fgets(text,LEN,Fi)==NULL || \
	    sscanf(text,"%d %d",&N,&M)!=2 || \
	    N<=0 || M<=0) Error(SG " bad number of pixels.")

	PIXELS(N0,M0,"SG0");

#define S(i)	(size_t)(i)

#define SOD	sizeof(double)

	if ((P=(double **)malloc(sizeof(double *)*S(M0+1)))==NULL ||
	    (*P=(double *)malloc(SOD*S(M0+1)*S(N0+2)))==NULL)
	    Error("SG0 memory allocation error.");

	for (m=0; m<=M0; m++) {
	    if (m==0) ++P[0]; else P[m]=P[m-1]+S(N0+2);

	    P[m][-1]=P[m][N0]=0.0;

	    if (m<M0 && fread(P[m],SOD,S(N0),Fi)!=N0)
		Error("SG0 data read error.");
	}
	if (Fi!=stdin) (void)fclose(Fi);

#define D(i)	(double)(i)

#define CENTER(arg,c,N,SG)	\
	if ((c=atof(arg))<=0.0 || c>=D(N-1)) \
	    Error(SG " bad position of rotation center.")

	CENTER(argv[2],c0,N0,"SG0");

#define I(d)	(int)(d)

	for (n=0; n<N0; n++)
	    if ((r=c0*2.0-D(n))>(-1.0) && r<D(N0)) {
		r-=D(n0=I(floor(r)));
		P[M0][n]=P[0][n0]*(1.0-r)+P[0][n0+1]*r;
	    }
	    else
		P[M0][n]=0.0;

	if (argc==10) {
	    OPEN(argv[3],"SG1");
	    PIXELS(N1,M1,"SG1");
	}
	else
	    if ((N1=atoi(argv[3]))<=0 ||
		(M1=atoi(argv[4]))<=0) Error("SG1 bad number of pixels.");

	CENTER(argv[argc-6],c1,N1,"SG1");

	if ((dr=atof(argv[argc-5]))<=0.0) Error("bad ratio of pixel size.");

	ot=(fmod(atof(argv[argc-4]),360.0)+360.0)*M_PI/180.0;

	o1=D(N1)/2.0-0.5; o2=dr*D(N0)/2.0-0.5;
	ox=atof(argv[argc-3])+o1-o2*(cos(ot)-sin(ot));
	oy=atof(argv[argc-2])+o1-o2*(sin(ot)+cos(ot));

	st=M_PI/D(M1);

	for (m=0; m<M1; m++) {
	    t=st*D(m); r=ox*cos(t)-oy*sin(t);
	    if (m==0) o1=o2=r; else if (r<o1) o1=r; else if (r>o2) o2=r;
	}
	n1=((r=dr*c0+o2-c1)<0.0)?0:I(ceil(r));
	n2=n1+N1;
	c2=c1+D(n1);
	N2=((n=I(ceil(dr*(D(N0-1)-c0)+c2-o1))+1)<n2)?n2:n;

	(void)fprintf(stderr,"%lf\n",c2);

	if (argv[argc-1][0]=='-')
	    Fo=stdout;
	else
	    if ((Fo=fopen(argv[argc-1],"wb"))==NULL)
		Error("SG2 file not stored.");

	(void)fprintf(Fo,"%d\t%d\n",N2,M1);

	for (m=0; m<M1; m++) {
	    t=st*D(m); r=ox*cos(t)-oy*sin(t)-c2;
	    if ((t=fmod(t+ot,M_PI*2.0)*D(M0)/M_PI)<D(M0))
		sr=1.0/dr;
	    else {
		t-=D(M0); sr=(-1.0)/dr;
	    }
	    t-=D(m0=I(t)); r0=c0+sr*r;

	    for (n=0; n<N2; n++) {
		if (argc==10 && n>=n1 && n<n2) {
		    if (fread(&p,SOD,S(1),Fi)!=1)
			Error("SG1 data read error.");
		}
		else if ((r=r0+sr*D(n))>(-1.0) && r<D(N0)) {
		    r-=D(n0=I(floor(r)));
		    p0=P[m0][n0];
		    pr=P[m0][n0+1]-p0;
		    pt=P[m0+1][n0]-p0;
		    p=p0+pr*r+pt*t+(P[m0+1][n0+1]-p0-pr-pt)*r*t;
		}
		else
		    p=0.0;

		(void)fwrite(&p,SOD,S(1),Fo);
	    }
	}
	if (Fo!=stdout) (void)fclose(Fo);

	if (argc==10 && Fi!=stdin) (void)fclose(Fi);

	free(P[0]-1); free(P);

	return 0;
}
