
#include <stdlib.h>

extern void	Error();

#define WORD	unsigned short

typedef struct List {
		WORD		h,v;
		struct List	*next;
	} List;

static void	(*Store)();

#define ALLOC(type,noe)	(type *)malloc((size_t)(noe)*sizeof(type))

static void	Flush(list)
List		*list;
{
	size_t	idx,cnt=0;
	List	**array,**head,**tail,*oList,*nList,*stack=list;
	int	oSide,nSide,h0,v0,h1,v1,h2,v2;

	while ((list=list->next)!=NULL) ++cnt;

	if ((array=ALLOC(List *,cnt))==NULL)
	    Error("array memory allocation error.");

	list=stack;
	for (idx=0; idx<cnt; idx++) {
	    array[idx]=list; list=list->next;
	}
	free(list);

	stack->next=NULL;

	head=array+1; tail=array+cnt-1;
	if ((*head)->v>(*tail)->v) {
	    oSide=0; oList=(*(head++));
	}
	else {
	    oSide=1; oList=(*(tail--));
	}
	while (head!=tail) {
	    if ((*head)->v>(*tail)->v) {
		nSide=0; nList=(*(head++));
	    }
	    else {
		nSide=1; nList=(*(tail--));
	    }

#define STORE_AND_POP(list1,list2)	\
	(*Store)((int)stack->h,(int)stack->v, \
		 (int)list1->h,(int)list1->v, \
		 (int)list2->h,(int)list2->v); \
	oList=stack; if ((stack=stack->next)==NULL) break

#define FLUSH_REMAINS()	\
	if (oSide==0) for (;;) { STORE_AND_POP(oList,nList); } else \
		      for (;;) { STORE_AND_POP(nList,oList); }

	    if (oSide==nSide) {
		h1=oList->h-(h0=nList->h);
		v1=oList->v-(v0=nList->v);
		if (oSide==0)
		    for (; v1*(h2=stack->h-h0)>
			   h1*(v2=stack->v-v0); h1=h2,
						v1=v2) {
			STORE_AND_POP(oList,nList);
		    }
		else
		    for (; v1*(h2=stack->h-h0)<
			   h1*(v2=stack->v-v0); h1=h2,
						v1=v2) {
			STORE_AND_POP(nList,oList);
		    }
	    }
	    else {
		list=oList; FLUSH_REMAINS()
		oList=list;
	    }
	    oList->next=stack; stack=oList; oList=nList; oSide=nSide;
	}
	nList=(*head); FLUSH_REMAINS()

	for (idx=0; idx<cnt; idx++) free(array[idx]); free(array);
}

static List	*Alloc(h,v,next)
int		h,v;
List		*next;
{
	List	*list=ALLOC(List,1);

	if (list==NULL) Error("list memory allocation error.");

	list->h=(WORD)h; list->v=(WORD)v; list->next=next; return list;
}

static List	*hori,**vert,**help,**ptr;

static void	Corner(h,v,lu,ld,ru,rd)
int		h,v,lu,ld,ru,rd;
{
	List	*temp,*next;

#define VERT	vert[h]
#define HELP	help[h]

	switch(((!lu)?8:0)|((!ld)?4:0)|((!ru)?2:0)|((!rd)?1:0)) {
	    case 0x1:
		VERT=Alloc(h,v+1,Alloc(h,v,hori=Alloc(h+1,v,NULL)));
		ptr=(&HELP);
		break;
	    case 0x2:
		VERT->v=(WORD)v;
		next=HELP->next;
		if (HELP->h==next->h && HELP->v==next->v) {
		    hori=Alloc(h+1,v,Alloc(h,v,next));
		    HELP->next=Alloc(h,v,NULL); Flush(VERT);
		}
		else
		    hori=Alloc(h+1,v,VERT);
		break;
	    case 0x3:
		ptr=(&HELP);
		break;
	    case 0x4:
		hori->h=(WORD)h; hori->next=VERT=Alloc(h,v+1,NULL);
		*ptr=hori;
		break;
	    case 0x6:
		VERT->v=(WORD)v;
		next=HELP->next;
		if (HELP->h==next->h && HELP->v==next->v) {
		    temp=Alloc(h+1,v,Alloc(h,v,next));
		    HELP->next=Alloc(h,v,NULL); Flush(VERT);
		}
		else
		    temp=Alloc(h+1,v,VERT);
		hori->h=(WORD)h; hori->next=VERT=Alloc(h,v+1,NULL);
		*ptr=hori;
		hori=temp;
		break;
	    case 0x7:
		hori->h=(WORD)h; VERT->v=(WORD)v;
		next=HELP->next;
		if (HELP->h==next->h && HELP->v==next->v) {
		    hori->next=Alloc(h,v,next);
		    HELP->next=Alloc(h,v,NULL); Flush(VERT);
		}
		else
		    hori->next=VERT;
		*ptr=hori;
		break;
	    case 0x8:
		VERT->v=(WORD)v; hori->h=(WORD)h; Flush(hori);
		break;
	    case 0x9:
		VERT->v=(WORD)v; hori->h=(WORD)h; Flush(hori);
		VERT=Alloc(h,v+1,Alloc(h,v,hori=Alloc(h+1,v,NULL)));
		ptr=(&HELP);
		break;
	    case 0xb:
		hori->h=(WORD)h; VERT=Alloc(h,v+1,hori);
		ptr=(&HELP); HELP=hori;
		break;
	    case 0xd:
		VERT->v=(WORD)v;
		temp=(*ptr); next=temp->next;
		if (temp->h==next->h && temp->v==next->v) {
		    Flush(Alloc(h,v,next));
		    temp->next=Alloc(h,v,hori=Alloc(h+1,v,NULL));
		}
		else
		    VERT->next=hori=Alloc(h+1,v,NULL);
		break;
	    case 0xe:
		temp=(*ptr); next=temp->next;
		if (temp->h==next->h && temp->v==next->v)
		    hori=Alloc(h+1,v,Alloc(h,v,next));
		else
		    hori=Alloc(h+1,v,Alloc(h,v,Alloc((int)temp->h,
						     (int)temp->v,next)));
		*ptr=temp->next=Alloc(h,v,VERT=Alloc(h,v+1,NULL));
		break;
	}
}

void	InitTriangulation(Nh,Nv,back)
int	Nh,Nv;
char	***back;
{
	int	h,v;

	if ((vert=ALLOC(List *,Nh+1))==NULL ||
	    (help=ALLOC(List *,Nh))==NULL ||
	    (*back=ALLOC(char *,Nv+1))==NULL ||
	    (**back=ALLOC(char,(Nv+1)*(Nh+1)))==NULL)
	    Error("work memory allocation error.");

	***back=1; ++(**back); ++(*back);

	for (h=0; h<Nh; h++) (*back)[-1][h]=1;

	for (v=0; v<Nv; v++) {
	    (*back)[v]=(*back)[v-1]+Nh+1; (*back)[v][-1]=1;
	}
}

void	Triangulation(hl,vu,hr,vd,back,store)
int	hl,vu,hr,vd;
char	**back;
void	(*store)();
{
	int	v,h;

	Store=store;

#define CORNER(ld,ru,rd)	Corner(h,v,(int)back[v-1][h-1],ld,ru,rd)

	for (v=vu; v<=vd; v++) {
	    for (h=hl; h<=hr; h++)
		CORNER((int)back[v][h-1],(int)back[v-1][h],(int)back[v][h]);

	    CORNER((int)back[v][h-1],1,1);
	}
	for (h=hl; h<=hr; h++) CORNER(1,(int)back[v-1][h],1); CORNER(1,1,1);
}

void	TermTriangulation(back)
char	**back;
{
	free(*(back-1)-1); free(back-1); free(help); free(vert);
}
